// 2012/05/20 ̂dZ 

#include <windows.h>
#include <stdio.h>

int main()
{
	char strFilePath[ 256 ] = { 0 };
	
	OPENFILENAME Ofn   = { 0 };
	Ofn.lStructSize    = sizeof( OPENFILENAME );
	Ofn.hwndOwner      = NULL;
	Ofn.lpstrFilter    = "csv files {*.csv}\0*.csv\0\0";
	Ofn.nMaxCustFilter = 256;
	Ofn.nFilterIndex   = 0;
	Ofn.lpstrFile      = strFilePath;
	Ofn.nMaxFile       = _MAX_PATH;
	Ofn.Flags          = OFN_FILEMUSTEXIST;
	
	char strExeDir[ _MAX_DIR ];
	GetCurrentDirectory( _MAX_PATH, strExeDir );
	
	if( !GetOpenFileName( &Ofn ) ) return 0;
	
	SetCurrentDirectory( strExeDir );
	
	//--------------------------------------------------------------------------------------------------
	// CSVǂݍ
	//--------------------------------------------------------------------------------------------------
	
	FILE* fp;
	fopen_s( &fp, Ofn.lpstrFile, "r" );
	
	const int TtlFrame  = 8192;
	const int TtlPlayer =    2;
	const int TtlCmd    =    7;
	
	char strCmd[ TtlFrame ][ TtlPlayer ][ TtlCmd + 1 ] = { 0 };
	
	for( int IdxFrame  = 0; IdxFrame  < TtlFrame;  IdxFrame++  )
	for( int IdxPlayer = 0; IdxPlayer < TtlPlayer; IdxPlayer++ )
	for( int IdxCmd    = 0; IdxCmd    < TtlCmd;    IdxCmd++    )
		strCmd[ IdxFrame ][ IdxPlayer ][ IdxCmd ] = '0';
	
	int IdxFrame = 0;
	
	while( true )
	{
		char strBuf[ 256 ] = { 0 };
		
		if( !fgets( strBuf, sizeof( strBuf ), fp ) ) break;
		
		int IdxPlayer = 0;
		
		for( int i = 0; i < sizeof( strBuf ); i++ )
		{
			switch( strBuf[ i ] )
			{
			case '1' : strCmd[ IdxFrame ][ IdxPlayer ][ 5 ] = '1';
			           strCmd[ IdxFrame ][ IdxPlayer ][ 6 ] = '1'; break;
			case '2' : strCmd[ IdxFrame ][ IdxPlayer ][ 5 ] = '1'; break;
			case '3' : strCmd[ IdxFrame ][ IdxPlayer ][ 4 ] = '1';
			           strCmd[ IdxFrame ][ IdxPlayer ][ 5 ] = '1'; break;
			case '4' : strCmd[ IdxFrame ][ IdxPlayer ][ 6 ] = '1'; break;
			case '6' : strCmd[ IdxFrame ][ IdxPlayer ][ 4 ] = '1'; break;
			case '7' : strCmd[ IdxFrame ][ IdxPlayer ][ 3 ] = '1';
			           strCmd[ IdxFrame ][ IdxPlayer ][ 6 ] = '1'; break;
			case '8' : strCmd[ IdxFrame ][ IdxPlayer ][ 3 ] = '1'; break;
			case '9' : strCmd[ IdxFrame ][ IdxPlayer ][ 3 ] = '1';
			           strCmd[ IdxFrame ][ IdxPlayer ][ 4 ] = '1'; break;
			case 'P' :
			case 'p' : strCmd[ IdxFrame ][ IdxPlayer ][ 2 ] = '1'; break;
			case 'K' :
			case 'k' : strCmd[ IdxFrame ][ IdxPlayer ][ 1 ] = '1'; break;
			case 'G' :
			case 'g' : strCmd[ IdxFrame ][ IdxPlayer ][ 0 ] = '1'; break;
			case ',' : IdxPlayer++; break;
			}
		}
		
		IdxFrame++;
	}
	
	fclose( fp );
	
	//--------------------------------------------------------------------------------------------------
	// CmdROMo
	//--------------------------------------------------------------------------------------------------
	
	FILE* fpSrc; fopen_s( &fpSrc, "CmdROM_form.vhd", "r" );
	FILE* fpDst; fopen_s( &fpDst, "CmdROM.vhd",      "w" );
	
	SYSTEMTIME stTime;
	GetLocalTime( &stTime );
	fprintf( fpDst, "-- %d/%02d/%02d Generated by CmdCSVToCmdROM\n", stTime.wYear, stTime.wMonth, stTime.wDay );
	
	char c;
	
	while( ( c = fgetc( fpSrc ) ) != EOF )
	{
		if( c == '#' )
		{
			for( int IdxFrame = 0; IdxFrame < TtlFrame; IdxFrame++ )
			{
				fputs(                  "\t\"", fpDst );
				fputs( strCmd[ IdxFrame ][ 1 ], fpDst );
				fputs( strCmd[ IdxFrame ][ 0 ], fpDst );
				
				fputs( ( IdxFrame == TtlFrame - 1 ) ? "\" );" : "\",\n", fpDst );
			}
		}
		else
		{
			fputc( c, fpDst );
		}
	}
	
	fclose( fpSrc );
	fclose( fpDst );
	
	MessageBox( NULL, "CmdROM.vhd𐶐܂", "CmdCSVToCmdROM", MB_OK );
	
	return 0;
}
